Crypto++

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Member Functions | Protected Attributes
SHA224 Class Reference

implements the SHA-224 standard More...

`#include <sha.h>`

Inheritance diagram for SHA224:

List of all members.

## Public Types

typedef BigEndian | ByteOrderClass
typedef word32 | HashWordType

## Public Member Functions

unsigned int | DigestSize () const
| size of the hash/digest/MAC returned by Final()
Clonable * | Clone () const
| this is not implemented by most classes yet
std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
unsigned int | BlockSize () const
| block size of underlying compression function, or 0 if not block based
ByteOrder | GetByteOrder () const
unsigned int | OptimalBlockSize () const
| input to Update() should have length a multiple of this for optimal speed
unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
void | Update (const byte *input, size_t length)
| process more input
byte * | CreateUpdateSpace (size_t &size)
| request space to write input into
void | Restart ()
| discard the current state, and restart with a new message
void | TruncatedFinal (byte *digest, size_t size)
| truncated version of Final()
HashTransformation & | Ref ()
| return a reference to this object, useful for passing a temporary object to a function that takes a non-const reference
virtual void | Final (byte *digest)
| compute hash for current message, then restart for a new message
unsigned int | TagSize () const
| same as DigestSize()
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Final() separately
virtual bool | Verify (const byte *digest)
| verify that digest is a valid digest for the current message, then reinitialize the object
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| use this if your input is in one piece and you don't want to call Update() and Verify() separately
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| truncated version of CalculateDigest()
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| truncated version of Verify()
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| truncated version of VerifyDigest()

## Static Public Member Functions

static void | InitState (HashWordType *state)
static void | Transform (word32 *digest, const word32 *data)
static const char * | StaticAlgorithmName ()
static void | CorrectEndianess (HashWordType *out, const HashWordType *in, size_t byteCount)

## Static Public Attributes

static const int | DIGESTSIZE
static const int | BLOCKSIZE
static CompileAssert <((T_BlockSize &(T_BlockSize-1))==0)> | cryptopp_assert___LINE__

## Protected Member Functions

void | HashEndianCorrectedBlock (const word32 *data)
void | Init ()
word32 * | StateBuf ()
word32 * | DataBuf ()
word32 | GetBitCountHi () const
word32 | GetBitCountLo () const
void | PadLastBlock (unsigned int lastBlockSize, byte padFirst=0x80)
virtual size_t | HashMultipleBlocks (const word32 *input, size_t length)
void | HashBlock (const HashWordType *input)
void | ThrowIfInvalidTruncatedSize (size_t size) const

## Protected Attributes

FixedSizeAlignedSecBlock < word32, T_BlockSize/sizeof(word32), T_StateAligned > | m_state
FixedSizeSecBlock< word32, T_BlockSize/sizeof(word32)> | m_data

## Detailed Description

implements the SHA-224 standard

Definition at line 32 of file sha.h.

## Member Function Documentation

virtual void HashTransformation::Final | ( | byte * | digest | ) | `[inline, virtual, inherited]`

compute hash for current message, then restart for a new message

Precondition:
  size of digest == DigestSize().

Definition at line 544 of file cryptlib.h.

Referenced by PKCS5_PBKDF2_HMAC< T >::DeriveKey().

virtual bool HashTransformation::Verify | ( | const byte * | digest | ) | `[inline, virtual, inherited]`

verify that digest is a valid digest for the current message, then reinitialize the object

Default implementation is to call Final() and do a bitwise comparison between its output and digest.

Definition at line 574 of file cryptlib.h.

The documentation for this class was generated from the following file:

- sha.h